#!/usr/bin/perl -I/usr/local/sauron -w
#
#
#=================================
# project: Sauron managment
# script:  add_host_options.pl
# version: 2.0\n";
#
# Automaticke pridani "dhcp_entries"
# zaznamum u jednotlivych hostu.
#=================================


#------------------------
# zacatek Sauroniho kodu
#------------------------

require 5;
use Getopt::Long;
use Sauron::DB;
use Sauron::Util;
use Sauron::BackEnd;
use Sauron::Sauron;

load_config();

fatal("cannot find $PROG_DIR/runsql (invalid configuration?)")
unless (-x "$PROG_DIR/runsql");

db_connect();
  
#----------------------
# konec Sauroniho kodu
#----------------------

mkdir TEMP;

print "Acquiring ID list ...\n";

`psql -c "select host, ip from a_entries" sauron > TEMP/id1.txt`;

#nastaveni jmen souboru
open(ID, "<TEMP/id1.txt");

#---------------------------------------------------------------------------
# Priprava pole obsahujiho usporadanou dvojici ID-domainname
#---------------------------------------------------------------------------

#nacteni dat
@iddata = <ID>;
if ($#iddata == 0){
  print "Error: no ID detected.\n";
  exit(1);
}

#lepsi naformatovani ID=HW
@tempdata = ();
$rows=0;
foreach(@iddata){
  if ($rows<2){
    #vynechani hlavicky
    $rows += 1;
  }
  else{
    if (($_ =~ /\|/) == 1){
      $_ =~ /\|/;
      $part1 = $`;
      $part2 = $';
      $part1 =~ /[^\s][^\s]*/;
      $part1 = $&;
      $part2 =~ /[^\s][^\s]*/;
      $part2 = $&;
      push @tempdata, "$part1=$part2";
    }
  }
}
@iddata = @tempdata;
close(ID);

#---------------------------------------------------------------------------
# Vygenerovani SQL prikazu ze vstupu
#---------------------------------------------------------------------------
@sql_lines = ();
foreach(<>){
  $_ =~ /^\s*[0-9][0-9\.]*[\s]*"/;
  $ip = $&;
  $entry= $';

  $ip =~ /[^\s"][^\s"]*/;
  $ip = $&;

  $entry =~ /"\s*\n$/;
  $entry = $`;
  #print "$ip=$entry\n";
  $id = &get_id($ip); 
  if ($id == -1){
    print "IP $ip not found.\n";  
  }
  else{
    print "DHCP entry '$entry' added to IP $ip\n";
    push @sql_lines, "insert into dhcp_entries (dhcp, type, ref) values ('$entry', 3, $id);\n";
  }
}

#---------------------------------------------------------------------------
# Priprava SQL prikazu pro pridani pozadovanych zaznamu
#---------------------------------------------------------------------------
print "Generating SQL commands ...\n";
open(SQL, ">TEMP/insert.sql");
foreach(@sql_lines){
  print SQL $_;
}
close(SQL);

die;

print "Executing SQL commands ...\n";

$res=system("$PROG_DIR/runsql","TEMP/insert.sql");
fatal("failed") if ($res);

print "Host options were successfully inserted.\n\n";
#---------------------------------------------------------------------------
# Podprogramy
#---------------------------------------------------------------------------
sub get_id{
  $hwsearch=$_[0];
  foreach(@iddata){
    $_ =~ /=/;
    $id = $`;
    $hw = $';
    if ($hw eq $hwsearch){
      ##print "$hw : $id\n";
      #prevod na format jako je v databazi
      return ($id);
    }
  }
  return(-1);
}

sub modify_hw {
   for (@_) { tr/a-z/A-Z/ };
   for (@_) { s/://};
   for (@_) { s/://};
   for (@_) { s/://};
   for (@_) { s/://};
   for (@_) { s/://};
}

